import { defineComponent, ref, computed, useCssVars, openBlock, createElementBlock, createElementVNode, withDirectives, vShow, Fragment, renderList, normalizeClass, pushScopeId, popScopeId } from "vue";
var iconfont = "";
var vueMirrorScope_vue_vue_type_style_index_0_scoped_true_lang = "";
var _export_sfc = (sfc, props) => {
  const target = sfc.__vccOpts || sfc;
  for (const [key, val] of props) {
    target[key] = val;
  }
  return target;
};
const __default__ = defineComponent({
  props: {
    imgList: {
      type: Array,
      default: () => []
    },
    size: {
      type: String,
      default: "400px"
    },
    expandScope: {
      type: Number,
      default: 3
    }
  },
  setup(props, { emit }) {
    const loadingRef = ref(true);
    const indexRef = ref(0);
    const visibleRef = ref(false);
    const listRef = ref(null);
    const pointerRef = ref(null);
    const containerRef = ref(null);
    const mirrorRef = ref(null);
    const prev = () => {
      listRef.value.scrollLeft -= 210;
    };
    const next = () => {
      listRef.value.scrollLeft += 210;
    };
    const mirrorSize = computed(() => {
      const match = props.size.match(/(\d+)(\w+)/);
      return Number(match[1]) * props.expandScope + match[2];
    });
    const pointerSize = computed(() => {
      return parseFloat(props.size) / props.expandScope + "px";
    });
    const move = (e) => {
      const container = containerRef.value.getBoundingClientRect();
      const pointer = pointerRef.value.getBoundingClientRect();
      let targetX = 0;
      let targetY = 0;
      if (e.offsetX + pointer.left - container.left - pointer.width / 2 < 0) {
        targetX = 0;
      } else if (e.offsetX + pointer.left - container.left > container.width - pointer.width / 2) {
        targetX = container.width - pointer.width;
      } else {
        targetX = e.offsetX + pointer.left - container.left - pointer.width / 2;
      }
      if (e.offsetY + pointer.top - container.top - pointer.height / 2 < 0) {
        targetY = 0;
      } else if (e.offsetY + pointer.top - container.top > container.height - pointer.height / 2) {
        targetY = container.height - pointer.height;
      } else {
        targetY = e.offsetY + pointer.top - container.top - pointer.height / 2;
      }
      pointerRef.value.style.left = targetX + "px";
      pointerRef.value.style.top = targetY + "px";
      let percentX = targetX / container.width * 100;
      let percentY = targetY / container.width * 100;
      mirrorRef.value.style.left = -percentX * props.expandScope + "%";
      mirrorRef.value.style.top = -percentY * props.expandScope + "%";
    };
    const enter = (e) => {
      visibleRef.value = true;
      const container = containerRef.value.getBoundingClientRect();
      let pointer_size = container.width / props.expandScope;
      if (e.offsetX - pointer_size / 2 < 0) {
        pointerRef.value.style.left = 0;
      } else if (e.offsetX + pointer_size / 2 >= container.width) {
        pointerRef.value.style.left = container.width - pointer_size + "px";
      } else {
        pointerRef.value.style.left = e.offsetX - pointer_size / 2 + "px";
      }
      console.log(e.offsetY, pointer_size, container.height - pointer_size);
      if (e.offsetY - pointer_size / 2 < 0) {
        pointerRef.value.style.top = 0;
      } else if (e.offsetY >= container.height - pointer_size) {
        pointerRef.value.style.top = container.height - pointer_size + "px";
      } else {
        pointerRef.value.style.top = e.offsetY - pointer_size / 2 + "px";
      }
    };
    return {
      loadingRef,
      indexRef,
      listRef,
      prev,
      next,
      mirrorSize,
      pointerRef,
      move,
      containerRef,
      mirrorRef,
      pointerSize,
      enter,
      visibleRef
    };
  }
});
const __injectCSSVars__ = () => {
  useCssVars((_ctx) => ({
    "35ecad4c": _ctx.size,
    "a1b84736": _ctx.pointerSize,
    "4b1e6af9": _ctx.mirrorSize
  }));
};
const __setup__ = __default__.setup;
__default__.setup = __setup__ ? (props, ctx) => {
  __injectCSSVars__();
  return __setup__(props, ctx);
} : __injectCSSVars__;
const _sfc_main = __default__;
const _withScopeId = (n) => (pushScopeId("data-v-14d6dca0"), n = n(), popScopeId(), n);
const _hoisted_1 = { class: "mirror" };
const _hoisted_2 = ["src"];
const _hoisted_3 = { class: "mirror-wrap" };
const _hoisted_4 = {
  class: "mirror-pic",
  ref: "mirrorRef"
};
const _hoisted_5 = ["src"];
const _hoisted_6 = { class: "mirror-list-wrap" };
const _hoisted_7 = {
  class: "mirror-list",
  ref: "listRef"
};
const _hoisted_8 = ["onMouseenter"];
const _hoisted_9 = ["src"];
const _hoisted_10 = /* @__PURE__ */ _withScopeId(() => /* @__PURE__ */ createElementVNode("i", { class: "iconfont icon-houtui" }, null, -1));
const _hoisted_11 = [
  _hoisted_10
];
const _hoisted_12 = /* @__PURE__ */ _withScopeId(() => /* @__PURE__ */ createElementVNode("i", { class: "iconfont icon-qianjin" }, null, -1));
const _hoisted_13 = [
  _hoisted_12
];
function _sfc_render(_ctx, _cache, $props, $setup, $data, $options) {
  return openBlock(), createElementBlock("div", _hoisted_1, [
    createElementVNode("div", {
      class: "big-pic",
      onMouseleave: _cache[2] || (_cache[2] = ($event) => _ctx.visibleRef = false)
    }, [
      createElementVNode("div", {
        class: "pic-container",
        ref: "containerRef",
        onMouseenter: _cache[1] || (_cache[1] = (...args) => _ctx.enter && _ctx.enter(...args))
      }, [
        createElementVNode("img", {
          src: _ctx.imgList[_ctx.indexRef]
        }, null, 8, _hoisted_2),
        withDirectives(createElementVNode("div", {
          class: "pointer",
          onMousemove: _cache[0] || (_cache[0] = (...args) => _ctx.move && _ctx.move(...args)),
          ref: "pointerRef"
        }, null, 544), [
          [vShow, _ctx.visibleRef]
        ])
      ], 544),
      withDirectives(createElementVNode("div", _hoisted_3, [
        createElementVNode("div", _hoisted_4, [
          createElementVNode("img", {
            src: _ctx.imgList[_ctx.indexRef]
          }, null, 8, _hoisted_5)
        ], 512)
      ], 512), [
        [vShow, _ctx.visibleRef]
      ])
    ], 32),
    createElementVNode("div", _hoisted_6, [
      createElementVNode("ul", _hoisted_7, [
        (openBlock(true), createElementBlock(Fragment, null, renderList(_ctx.imgList, (img, index) => {
          return openBlock(), createElementBlock("li", {
            key: index,
            onMouseenter: ($event) => _ctx.indexRef = index,
            class: normalizeClass({ active: _ctx.indexRef === index })
          }, [
            createElementVNode("img", { src: img }, null, 8, _hoisted_9)
          ], 42, _hoisted_8);
        }), 128))
      ], 512),
      createElementVNode("span", {
        onClick: _cache[3] || (_cache[3] = (...args) => _ctx.prev && _ctx.prev(...args))
      }, _hoisted_11),
      createElementVNode("span", {
        onClick: _cache[4] || (_cache[4] = (...args) => _ctx.next && _ctx.next(...args))
      }, _hoisted_13)
    ])
  ]);
}
var VueMirrorScope = /* @__PURE__ */ _export_sfc(_sfc_main, [["render", _sfc_render], ["__scopeId", "data-v-14d6dca0"]]);
VueMirrorScope.install = (app) => {
  app.component(VueMirrorScope.name, VueMirrorScope);
};
export { VueMirrorScope as default };
